/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//	MOVIE.H						(c)	YoY'01						WEB: www.aestesis.org
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef							_MOVIE_H_
#define							_MOVIE_H_
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include						<windows.h>
#include						<uuids.h>		// ID Com Object
#include						<VFW.H>		// Video For Windows
#include						<amstream.h>	// DirectShow multimedia stream interfaces
#include						<ddraw.h>	    // DirectDrawEx interfaces

#include						"types.h"
#include						"node.h"
#include						"bitmap.h"
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//	If you use directly the variables in the class API, it's at your own risks. Prefer the methods...   

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define							guidMOVIE						(Afile::CI.guid)

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class Amovie : public Anode
{
public:

	enum
	{
								CURRENT=-100,
								FIRST,
								LAST,
								NEXT,
								PREVIOUS
	};

	enum
	{
								typeNORMAL,
								typeSTREAMLOAD,
								typeFLIFLCLOAD
	};

	ADLL static ACI				CI;
	virtual ACI					*getCI							()						{ return &CI; }

	ADLL						Amovie							(char *name, int w, int h, int nbBits, int nbFrames=0);
	ADLL						Amovie							(char *name, char *filename);
	ADLL virtual				~Amovie							();

	ADLL void					clear							();

	ADLL bool					remove							(int pos=CURRENT);
	ADLL bool					insert							(class Abitmap *b=NULL, int pos=CURRENT);
	ADLL bool					append							(class Abitmap *b=NULL, int pos=CURRENT);
	ADLL bool					select							(int pos=NEXT);

	ADLL bool					get								(class Abitmap *b, int pos=CURRENT);

	//ADLL bool					get								(class Abitmap *b, int xd, int yd, int state, int pos=CURRENT);
	//ADLL bool					get								(class Abitmap *b, int xd, int yd, int xs, int ys, int w, int h, int pos=CURRENT);
	ADLL bool					get								(class Abitmap *b, int xd, int yd, int wd, int hd, int xs, int ys, int ws, int hs, int state, int flags, float alpha, dword colorkey, int pos=CURRENT);

	class bitmapL				*firstB;
	class bitmapL				*lastB;

	class bitmapL				*current;
	int							currentI;

	int							w;
	int							h;
	int							nbBits;
	int							nbFrames;

	int							type;
	bool						isOK;

	// private DXmedia

	bool						open							(char *filename);
	void						close							();

    IAMMultiMediaStream			*m_pMMStream;
	IMediaStream				*m_pPrimaryVidStream;
	IDirectDrawMediaStream		*m_pDDStream;
	IDirectDrawSurface			*m_pDDSurfaceAnim;
	IDirectDrawStreamSample		*m_pSample;
	STREAM_TIME					fTime;
	bool						isLast;

	// pricate FLI/FLC

	struct fli					*fliflc;
	class Abitmap				*bfli;
	bool						openFLI							(char *filename);
	void						closeFLI						();

	bool						del								(class bitmapL *bl);
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif							//_MOVIE_H_
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
